# codecvt_abstract_base< InternT, ExternT, StateT > Class Template Reference

Common base for codecvt facet. More...

`#include <codecvt.h>`

Inheritance diagram for codecvt_abstract_base< InternT, ExternT, StateT >:

[legend]
Collaboration diagram for codecvt_abstract_base< InternT, ExternT, StateT >:

[legend]
List of all members.

## Public Member Functions

result | out (state_type &state, const intern_type *__from, const intern_type *__from_end, const intern_type *&__from_next, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const
| Convert from internal to external character set.
result | unshift (state_type &state, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const
| Reset conversion state.
result | in (state_type &state, const extern_type *__from, const extern_type *__from_end, const extern_type *&__from_next, intern_type *__to, intern_type *__to_end, intern_type *&__to_next) const
| Convert from external to internal character set.

## Protected Member Functions

virtual result | do_out (state_type &state, const intern_type *__from, const intern_type *__from_end, const intern_type *&__from_next, extern_type *__to, extern_type *__to_end, extern_type *&__to_next) const =0
| Convert from internal to external character set.

## Detailed Description

### template<typename InternT, typename ExternT, typename StateT>
class codecvt_abstract_base< InternT, ExternT, StateT >

Common base for codecvt facet.

This template class provides implementations of the public functions that forward to the protected virtual functions.

This template also provides abstract stubs for the protected virtual functions.

Definition at line 74 of file codecvt.h.

## Member Function Documentation

template<typename InternT, typename ExternT, typename StateT>
virtual result codecvt_abstract_base< InternT, ExternT, StateT >::do_out | ( | state_type & | state,
|  | const intern_type * | __from,
|  | const intern_type * | __from_end,
|  | const intern_type *& | __from_next,
|  | extern_type * | __to,
|  | extern_type * | __to_end,
|  | extern_type *& | __to_next
| ) | const`[protected, pure virtual]`

Convert from internal to external character set.

Converts input string of intern_type to output string of extern_type. This function is a hook for derived classes to change the value returned.

See also:
  out for more information.

template<typename InternT, typename ExternT, typename StateT>
result codecvt_abstract_base< InternT, ExternT, StateT >::in | ( | state_type & | state,
|  | const extern_type * | __from,
|  | const extern_type * | __from_end,
|  | const extern_type *& | __from_next,
|  | intern_type * | __to,
|  | intern_type * | __to_end,
|  | intern_type *& | __to_next
| ) | const`[inline]`

Convert from external to internal character set.

Converts input string of extern_type to output string of intern_type. This is analogous to mbsrtowcs. It does this by calling codecvt::do_in.

The source and destination character sets are determined by the facet's locale, internal and external types.

The characters in [from,from_end) are converted and written to [to,to_end). from_next and to_next are set to point to the character following the last successfully converted character, respectively. If the result needed no conversion, from_next and to_next are not affected.

The state argument should be intialized if the input is at the beginning and carried from a previous call if continuing conversion. There are no guarantees about how state is used.

The result returned is a member of codecvt_base::result. If all the input is converted, returns codecvt_base::ok. If no conversion is necessary, returns codecvt_base::noconv. If the input ends early or there is insufficient space in the output, returns codecvt_base::partial. Otherwise the conversion failed and codecvt_base::error is returned.

Parameters:

  | state | Persistent conversion state data.
  | from | Start of input.
  | from_end | End of input.
  | from_next | Returns start of unconverted data.
  | to | Start of output buffer.
  | to_end | End of output buffer.
  | to_next | Returns start of unused output area.

Returns:
  codecvt_base::result.

Definition at line 200 of file codecvt.h.

template<typename InternT, typename ExternT, typename StateT>
result codecvt_abstract_base< InternT, ExternT, StateT >::out | ( | state_type & | state,
|  | const intern_type * | __from,
|  | const intern_type * | __from_end,
|  | const intern_type *& | __from_next,
|  | extern_type * | __to,
|  | extern_type * | __to_end,
|  | extern_type *& | __to_next
| ) | const`[inline]`

Convert from internal to external character set.

Converts input string of intern_type to output string of extern_type. This is analogous to wcsrtombs. It does this by calling codecvt::do_out.

The source and destination character sets are determined by the facet's locale, internal and external types.

The characters in [from,from_end) are converted and written to [to,to_end). from_next and to_next are set to point to the character following the last successfully converted character, respectively. If the result needed no conversion, from_next and to_next are not affected.

The state argument should be intialized if the input is at the beginning and carried from a previous call if continuing conversion. There are no guarantees about how state is used.

The result returned is a member of codecvt_base::result. If all the input is converted, returns codecvt_base::ok. If no conversion is necessary, returns codecvt_base::noconv. If the input ends early or there is insufficient space in the output, returns codecvt_base::partial. Otherwise the conversion failed and codecvt_base::error is returned.

Parameters:

  | state | Persistent conversion state data.
  | from | Start of input.
  | from_end | End of input.
  | from_next | Returns start of unconverted data.
  | to | Start of output buffer.
  | to_end | End of output buffer.
  | to_next | Returns start of unused output area.

Returns:
  codecvt_base::result.

Definition at line 121 of file codecvt.h.

template<typename InternT, typename ExternT, typename StateT>
result codecvt_abstract_base< InternT, ExternT, StateT >::unshift | ( | state_type & | state,
|  | extern_type * | __to,
|  | extern_type * | __to_end,
|  | extern_type *& | __to_next
| ) | const`[inline]`

Reset conversion state.

Writes characters to output that would restore state to initial conditions. The idea is that if a partial conversion occurs, then the converting the characters written by this function would leave the state in initial conditions, rather than partial conversion state. It does this by calling codecvt::do_unshift().

For example, if 4 external characters always converted to 1 internal character, and input to in() had 6 external characters with state saved, this function would write two characters to the output and set the state to initialized conditions.

The source and destination character sets are determined by the facet's locale, internal and external types.

The result returned is a member of codecvt_base::result. If the state could be reset and data written, returns codecvt_base::ok. If no conversion is necessary, returns codecvt_base::noconv. If the output has insufficient space, returns codecvt_base::partial. Otherwise the reset failed and codecvt_base::error is returned.

Parameters:

  | state | Persistent conversion state data.
  | to | Start of output buffer.
  | to_end | End of output buffer.
  | to_next | Returns start of unused output area.

Returns:
  codecvt_base::result.

Definition at line 160 of file codecvt.h.

The documentation for this class was generated from the following file:

- codecvt.h